

//   LINKEDLISTT.CC

#include "linkedlistT.h"

template <class ElementType>
LinkedListT<ElementType>::LinkedListT() 
        { header = new Node<ElementType>();}
        

template <class ElementType>
void LinkedListT<ElementType>::Insert(ElementType *elementptr) {
     Node<ElementType> *newnode;
     newnode  = new Node<ElementType>(elementptr);
     newnode->next = header->next;
     header->next = newnode; 
    }
     
template <class ElementType>
void LinkedListT<ElementType>::Delete(ElementType *elementptr) {
     Node<ElementType> *current,*oldcurrent;
     oldcurrent = header; 
     current = header->next;
     while( current != NULL && (current->data)->notequal(elementptr)  )
             {  oldcurrent = current;  current = current->next; };
     if(current != NULL) 
          {
           oldcurrent->next  = current->next;
           delete current;
          }
    }

template <class ElementType>
bool LinkedListT<ElementType>::Member(ElementType *elementptr) {
     Node<ElementType> *current;
     current = header->next;
     while( current != NULL && (current->data)->notequal(elementptr) )
          current = current->next;
     if(current == NULL) 
        return(false);
        else return(true);
    }

template <class ElementType>
bool LinkedListT<ElementType>::Empty()
     {  if( header->next == NULL) 
          return(true);
          else return(false);
     } 

template <class ElementType>
void LinkedListT<ElementType>::PrintList() 
     {
     Node<ElementType> *current;
      if(Empty())
        cout << " - empty - \n";
        else 
           {
            current = header->next;
            while( current != NULL )
             {
               current->PrintNode();
               current = current->next; 
               cout << ", ";
             }
            cout << "\n";
           }
}

template <class ElementType>
int LinkedListT<ElementType>::Length()
      {
       Node<ElementType> *current = header->next;
       int counter = 0; 
       while( current != NULL )
         { current = current->next; 
           counter++;
         }
       return counter;
      }


template <class ElementType>
LinkedListT<ElementType>::~LinkedListT()     // Go through every Node of linked
   {                          //  list and delete each Node.
     Node<ElementType> *current, *previous;
     current = header;
     while( current != NULL )
         {  previous = current;
            current = current->next;
            delete previous;
         }
    }

